// ATest.java - ACAP java tester
// Rob Earhart
// $Id$
//
/***********************************************************
        Copyright 1997 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of CMU not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
******************************************************************/

package acap;

import java.util.Vector;

class TestNotifier extends NotifyHandler {
  public void AddTo(String entry, int position, Vector values) {
    System.out.println("AddTo: " + entry + " at " + Integer.toString(position));
  }
  public void Change(String entry, int oldposition, int newposition, Vector values) {
    System.out.println("Change: " + entry + " from " + Integer.toString(oldposition) + " to " + Integer.toString(newposition));
  }
  public void RemoveFrom(String entry, int position) {
    System.out.println("RemoveFrom: " + entry + " at " + Integer.toString(position));
  }
  public void ModTime(String time) {
    System.out.println("Modtime: " + time);
  }
}

class ATest {
  private static acap.Conn conn = null;
  public static void main(String arg[])
    throws java.io.IOException, acap.acapException {
      conn = new acap.Conn("acap.andrew.cmu.edu");
      System.out.println("Connected.");
      String state = conn.login("anon", "rob");
      System.out.println("Login completed - " + state);
      String data[] = {"foo", "bar"};
      state = conn.store("/anon", "test", data);
      System.out.println("Store completed - " + state);
      Vector res = new Vector();
      StringBuffer modtime = new java.lang.StringBuffer();
      acap.Return rets[] = {};
      state = conn.search("/bookmarks",
			  new acap.Modifiers(null, "bookmarks", rets, null),
			  new acap.Compare("entry", "+octet", ""),
			  res, modtime);
      System.out.println("Search completed - " + state);
      String attrs[] = { "bookmark.url" };
      state = conn.notifycontext("bookmarks", attrs, new TestNotifier());
      System.out.println("NotifyContext completed - " + state);
      data[0] = "bookmark.url";
      data[1] = "file:/afs/andrew/acs/asg/rob/src/java/metamark/metatest.html";
      state = conn.store("/bookmarks", "MetaMark Test", data);
      System.out.println("Store completed - " + state);
      try {
	Thread.sleep(10000);
      } catch (InterruptedException e) {}
  }
}
